#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/times.h>
#include <time.h>

#include "NLKernel_learn.h"

TEjemplo tabla_ejemplos[MAXEJEMPLOS];
int num_ejemplos,num_dimensiones,num_vec_reduc;
double gamm;
double K[MAXEJEMPLOS][MAXEJEMPLOS],alfa[MAXEJEMPLOS][MAXEJEMPLOS],Aux[MAXEJEMPLOS][MAXEJEMPLOS];
double ALPHA,BETA,B[MAXEJEMPLOS],Y[MAXEJEMPLOS],W[MAXEJEMPLOS],Work[MAXEJEMPLOS*MAXEJEMPLOS];
int EME,ENE,KA,LDA,LDB,LDC,LWORK,INCX,INCY,INFO;

main(int argc, char *argv[])
{
  int i,j,l;
  char car1,car2;
  struct tms buffer_time;
  clock_t tiempo;
  double acum,nuevoacum;
    
  /* Comprobamos correccion de la linea de comandos. */
  if(argc!=6) {
    printf("USO: NLKernel_learn ancho_rbf(double) fich_entrada fich_salida TANTOPORUNO/NUM.VEC.PROP. TANTOPORUNO-REDUCCION\n");
    exit(0);
  }

  /* Leemos gamma y TANTOPORUNO de la linea de comandos: */
  gamm = (double)atof(argv[1]);
  TANTOPORUNO = (double)atof(argv[4]);

  /*printf("EPSILON=%lf\n",EPSILON);*/
 
  /* Leemos el fichero en memoria: */
  leer_ejemplos(argv[2]);
  printf("%d ejemplos, %d dimensiones\n",num_ejemplos,num_dimensiones);
  /*for(i=0;i<num_ejemplos;i++){
    printf("\nClase:%d - ",tabla_ejemplos[i].clase);
    for(j=0;j<num_dimensiones;j++){
      printf("%lf ",tabla_ejemplos[i].vector[j]);
    }
  }*/

  num_vec_reduc = (int)rint(num_ejemplos * atof(argv[5]));

  times(&buffer_time);
  tiempo = buffer_time.tms_utime;
  
  /* Calculamos la matriz de productos internos: */
  for(i=0;i<num_ejemplos;i++)
    for(j=0;j<num_vec_reduc;j++) {
      K[i][j] = kernel(tabla_ejemplos[i].vector,tabla_ejemplos[j].vector);
    }

  printf("Fin del calculo de K(%dx%d)\n",num_ejemplos,num_vec_reduc);

  /* Matriz artificial para pruebas:
  num_ejemplos = 4;
  num_vec_reduc = 3;
  K[0][0] = 1.0;
  K[0][1] = 0.5;
  K[0][2] = 0.3;
  
  K[1][0] = 0.5;
  K[1][1] = 1.0;
  K[1][2] = 0.8;
  
  K[2][0] = 0.3;
  K[2][1] = 0.8;
  K[2][2] = 1.0;
  
  K[3][0] = 0.7;
  K[3][1] = 0.9;
  K[3][2] = 0.2;
  */

  /* Calculamos alfa=Trans(K).K */
  car1 = 'N';
  car2 = 'T';
  EME = num_vec_reduc;
  ENE = num_vec_reduc;
  KA = num_ejemplos;
  ALPHA = 1;
  LDA = MAXEJEMPLOS;
  LDB = MAXEJEMPLOS;
  BETA = 0;
  LDC = MAXEJEMPLOS;
  dgemm_(&car1,&car2,&EME,&ENE,&KA,&ALPHA,K,&LDA,K,&LDB,&BETA,alfa,&LDC);

  /* Imprimimos la matriz alfa */
  /*printf("Trans(K).K):\n");
  for(i=0;i<num_vec_reduc;i++) {
    for(j=0;j<num_vec_reduc;j++) {
        printf("%lf ",alfa[i][j]);
    }
    printf("\n");
  }*/
  
  acum = 0;
  for(i=0;i<num_vec_reduc;i++)
    acum += alfa[i][i];
  printf("Traza de Tr(K).K = %le\n",acum);
 
  printf("Calculando descomposicion espectral...");
  fflush(stdout);
  ENE = num_vec_reduc;
  car1 = 'V';
  car2 = 'L';
  LWORK = 3*ENE;
  LDA = MAXEJEMPLOS;
  dsyev_(&car1,&car2,&ENE,alfa,&LDA,W,Work,&LWORK,&INFO);
  if(INFO!=0) {
    printf("ERROR en el calculo de valores propios\n");
    exit(-1);
  }
  printf("...Calculada.\n");


  /* Imprimimos la matriz alfa */
  /*printf("ALFA:\n");
  for(i=0;i<num_vec_reduc;i++) {
    for(j=0;j<num_vec_reduc;j++) {
        printf("%lf ",alfa[i][j]);
    }
    printf("\n");
  }*/
    
  nuevoacum = 0;
  for(i=0;i<num_vec_reduc;i++)
    nuevoacum += W[i];
  printf("Suma de todos los valores propios= %le\n",nuevoacum);

  acum = 0;
  for(i=0;i<num_vec_reduc;i++)
    if(W[i]<0)
      acum += W[i];
  printf("Suma de los valores propios negativos= %le\n",acum);


  /* Calculamos (lambda-1)*alfa, y lo ponemos en K):
   * NOTA: Nos quedamos solo con un porcentaje del espectro total de la
   * matriz. Los vectores propios quedan en las filas l..num_ejemplos-1 de
   * la matriz alfa.
   */
  if(TANTOPORUNO<=1.0) { 
    acum = 0;
    for(i=num_vec_reduc-1;i>=0;i--) {
      acum += W[i];
      if(acum >= TANTOPORUNO*nuevoacum)
        break;
    }
    l = i;
  } else { /*En vez de tantoporuno, tomamos un numero fijo de valores propios.*/
    l = (int) (num_vec_reduc - floor(TANTOPORUNO));
    acum = 0;
    for(i=num_vec_reduc-1;i>=l;i--) 
      acum += W[i];
  }
  
  printf("%d valores propios tomados en cuenta.\n",num_vec_reduc-l);
  printf("Suma de los valores propios tomados = %lf\n",acum);

  /* alfa*Tranpose(K); el resultado queda en Aux: */
  /* (OJO: Las matrices van transpuestas, pues es llamada a FORTRAN) */
  /* (OJO: Multiplicamos filas de mas, aunque no sean necesarias luego,
   * por no tener que mover filas en la matriz).
   */
  car1 = 'T';
  car2 = 'N';
  EME = num_vec_reduc;
  ENE = num_ejemplos;
  KA = num_vec_reduc;
  ALPHA = 1;
  LDA = MAXEJEMPLOS;
  LDB = MAXEJEMPLOS;
  BETA = 0;
  LDC = MAXEJEMPLOS;
  dgemm_(&car1,&car2,&EME,&ENE,&KA,&ALPHA,alfa,&LDA,K,&LDB,&BETA,Aux,&LDC);

  /* Imprimimos la matriz Aux (RECORDAR que queda traspuesta)*/
  /*printf("AUX:\n");
  for(i=0;i<num_ejemplos;i++) {
    for(j=0;j<num_vec_reduc;j++) {
        printf("%lf ",Aux[i][j]);
    }
    printf("\n");
  }*/


  /* Multiplicamos por lambda-1, y dejamos el resultado en K (aprovechamos
   * para 'destrasponerla'.
   */
  for(i=l;i<num_vec_reduc;i++) {
    for(j=0;j<num_ejemplos;j++) {
      K[i-l][j] = Aux[j][i]/W[i];
      alfa[i-l][j] = alfa[i][j];
    }  
  }

  /* Imprimimos la matriz K:*/
  /*printf("K:\n");
  for(i=0;i<num_vec_reduc;i++) {
    for(j=0;j<num_ejemplos;j++) {
        printf("%lf ",K[i][j]);
    }
    printf("\n");
  }*/

  /* Premultiplicamos por Tr(alfa): */
  /* (OJO: Las matrices van transpuestas, pues es llamada a FORTRAN) */
  car1 = 'N';
  car2 = 'T';
  EME = num_vec_reduc;
  ENE = num_ejemplos;
  KA = num_vec_reduc-l;
  ALPHA = 1;
  LDA = MAXEJEMPLOS;
  LDB = MAXEJEMPLOS;
  BETA = 0;
  LDC = MAXEJEMPLOS;
  dgemm_(&car1,&car2,&EME,&ENE,&KA,&ALPHA,alfa,&LDA,K,&LDB,&BETA,Aux,&LDC);

  /* Imprimimos la matriz Aux (pseudoinversa final). Recordar que, de nuevo,
   * las matriz resultado queda transpuesta:
   */
  /*printf("Pseudoinversa:\n");
  for(i=0;i<num_ejemplos;i++) {
    for(j=0;j<num_vec_reduc;j++) {
        printf("%lf ",Aux[i][j]);
    }
    printf("\n");
  }*/

  /* Por ultimo calculamos el vector k+.b, que junto con la base de vectores
   * de entrada constituira nuestra maquina.
   */
  for(i=0;i<num_ejemplos;i++)
    B[i] = (double) tabla_ejemplos[i].clase;
        
  /* Ejemplo artificial: */
  /*B[0] = 1;
  B[1] = 1;    
  B[2] = -1;
  B[3] = 1;*/
    
  car1 = 'N';
  EME = num_vec_reduc;
  ENE = num_ejemplos;
  ALPHA = 1;
  LDA = MAXEJEMPLOS;
  INCX = 1;
  BETA = 0;
  INCY = 1;
  dgemv_(&car1,&EME,&ENE,&ALPHA,Aux,&LDA,B,&INCX,&BETA,Y,&INCY);

  times(&buffer_time);
  printf("Tiempo (minutos de CPU)=%2.2f\n",(double)(buffer_time.tms_utime-tiempo)/(CLK_TCK*60));
  
  /* Imprimimos el vector solucion (maquina). */
  /*for(i=0;i<num_vec_reduc;i++)
    printf("Y[%d]=%lf ",i,Y[i]);
  printf("\n");*/

  /* Escribimos la maquina en el fichero: */
  escribir_maquina(argv[3]);
}


void leer_ejemplos(char *fichero)
{
  int i,clase,atributo;
  double valor;
  FILE *f;

  f=fopen(fichero,"r");
  if(f==NULL) {
    perror("Error en apertura de fichero de ejemplos.");
    exit(-1);
  }
  fscanf(f,"%d",&clase);
  num_ejemplos=0;
  num_dimensiones=0;

  while(1) {
    tabla_ejemplos[num_ejemplos].clase = clase;
    for(i=0;i<MAXDIM;i++)
      tabla_ejemplos[num_ejemplos].vector[i] = 0.0;   
    while(fscanf(f,"%d:%lf ",&atributo,&valor)==2){
      tabla_ejemplos[num_ejemplos].vector[atributo-1] = valor;
      if(atributo>num_dimensiones)
        num_dimensiones=atributo;
    }
    num_ejemplos++;
    if(feof(f)){
      break;
    }
    clase=atributo;
  }
  fclose(f);
}

void escribir_maquina(char *fichero)
{
  int i,j;
  FILE *f;

  f=fopen(fichero,"w");
  if(f==NULL) {
    perror("Error en escritura de fichero de maquina.");
    exit(-1);
  }

  /* Escribimos el valor de gamma: */
  fprintf(f,"%lf\n",gamm);
  /* Escribimos el numero de ejemplos y el vector Y: */
  fprintf(f,"%d\n",num_vec_reduc);
  for(i=0;i<num_vec_reduc;i++) 
    fprintf(f,"%lf ",Y[i]);
  fprintf(f,"\n");
  /* Escribimos los ejemplos del modelo: */
  for(i=0;i<num_vec_reduc;i++) {
    fprintf(f,"%d ",tabla_ejemplos[i].clase);
    for(j=0;j<num_dimensiones;j++) 
      if(tabla_ejemplos[i].vector[j]!=0.0)
        fprintf(f,"%d:%lf ",j+1,tabla_ejemplos[i].vector[j]);
    fprintf(f,"\n");
  }
  fclose(f);  
}


double kernel(double *v1,double *v2)
{
  int i;
  double acum=0;
  
  /* RBF: */
  for(i=0;i<num_dimensiones;i++) {
    acum += (v1[i]-v2[i])*(v1[i]-v2[i]);
  }
  return exp(-gamm*acum);
  
  /* LINEAL: */
/*  for(i=0;i<num_dimensiones;i++) {
    acum += v1[i]*v2[i];
  }
  return acum;*/
}

void copiar_matriz(double mat_ori[][MAXEJEMPLOS],double mat_dest[][MAXEJEMPLOS],int dim)
{
  int i,j;
  
  for(i=0;i<dim;i++)
    for(j=0;j<dim;j++)
      mat_dest[i][j] = mat_ori[i][j];
};
