#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/times.h>
#include <time.h>

#include "Kernel_Mahalanobis_learn.h"

TEjemplo tabla_ejemplos[MAXEJEMPLOS];
int num_ejemplos,num_ejemplos_sep[2],num_reduc_sep[2],num_dimensiones;
double gamm;
double K[2][MAXEJEMPLOSSEP][MAXEJEMPLOSSEP];
double WW[2][MAXEJEMPLOSSEP],Work[MAXEJEMPLOSSEP*MAXEJEMPLOSSEP],UNOK[2][MAXEJEMPLOSSEP];
double UNOKUNO[2];
int LDA,LWORK,ENE,INFO;
double XTX[3][3],XTXInv[3][3],XTB[3],W[3]; /* Para el separador lineal */
double dist[MAXEJEMPLOS][3];

int main(int argc, char *argv[])
{
  int i,j,k,l,p,iii,ii[2],jj[2],indice1,indice2;
  char car1,car2;
  struct tms buffer_time;
  clock_t tiempo;
  double acum,acum2[2],nuevoacum,temp,valdet;
  double txmmx[2][MAXEJEMPLOSSEP];
    
  /* Comprobamos correccion de la linea de comandos. */
  if(argc!=5) {
    printf("USO: NLKernel_learn ancho_rbf(double) fich_entrada fich_salida TANTOPORUNO/NUM.VEC.PROP.\n");
    exit(0);
  }

  /* Leemos gamma y TANTOPORUNO de la linea de comandos: */
  gamm = (double)atof(argv[1]);
  TANTOPORUNO = (double)atof(argv[4]);

  /*printf("EPSILON=%lf\n",EPSILON);*/
 
  /* Leemos el fichero en memoria: */
  leer_ejemplos(argv[2]);
  printf("%d ejemplos, %d dimensiones\n",num_ejemplos,num_dimensiones);
  /*for(i=0;i<num_ejemplos;i++){
    printf("\nClase:%d - ",tabla_ejemplos[i].clase);
    for(j=0;j<num_dimensiones;j++){
      printf("%lf ",tabla_ejemplos[i].vector[j]);
    }
  }*/

  /*num_vec_reduc = (int)rint(num_ejemplos * atof(argv[5]));*/

  times(&buffer_time);
  tiempo = buffer_time.tms_utime;
  
  /* Calculamos las matrices de productos internos: */
  num_ejemplos_sep[0] = 0;
  num_ejemplos_sep[1] = 0;
  ii[0] = -1;
  ii[1] = -1;  
  for(i=0;i<num_ejemplos;i++) {
    jj[0] = -1;
    jj[1] = -1;
    indice1 = (tabla_ejemplos[i].clase==1?1:0);
    ii[indice1]++;
    for(j=0;j<num_ejemplos;j++) {
      indice2 = (tabla_ejemplos[j].clase==1?1:0);
      if(indice1==indice2) {
        jj[indice1]++;
        if(ii[indice1]<=jj[indice1]) {
          K[indice1][ii[indice1]][jj[indice1]] = kernel(tabla_ejemplos[i].vector,tabla_ejemplos[j].vector);
        } else {
          K[indice1][ii[indice1]][jj[indice1]] = K[indice1][jj[indice1]][ii[indice1]];
        }
      }
    }
  }
  num_ejemplos_sep[0]=ii[0]+1;
  num_ejemplos_sep[1]=ii[1]+1;

  printf("Fin del calculo de K1(%dx%d) y K2(%dx%d)\n",num_ejemplos_sep[0],
         num_ejemplos_sep[0],num_ejemplos_sep[1],num_ejemplos_sep[1]);

  /* Matriz artificial para pruebas:
  num_ejemplos = 4;
  num_vec_reduc = 3;
  K[0][0] = 1.0;
  K[0][1] = 0.5;
  K[0][2] = 0.3;
  
  K[1][0] = 0.5;
  K[1][1] = 1.0;
  K[1][2] = 0.8;
  
  K[2][0] = 0.3;
  K[2][1] = 0.8;
  K[2][2] = 1.0;
  
  K[3][0] = 0.7;
  K[3][1] = 0.9;
  K[3][2] = 0.2;
  */

  /* Calculamos UNO.K (Como tiene iguales todas las filas, slo calculamos una;
   * del mismo modo, K.UNO tiene iguales todas las columnas(en realidad es slo
   * la traspuesta de UNO.K)):
   */
  for(l=0;l<2;l++){
    for(i=0;i<num_ejemplos_sep[l];i++) {
      UNOK[l][i] = 0;
      for(j=0;j<num_ejemplos_sep[l];j++) {
        UNOK[l][i] += K[l][j][i]/num_ejemplos_sep[l];
      }
    }
  }
  /* Calculamos tambin UNO.K.UNO: Es simplemente una matriz con todas las celdas
   * iguales a la suma de todos los elementos de K, partido por num_ejemplos al
   * cuadrado:
   */
  UNOKUNO[0] = 0;
  UNOKUNO[1] = 0;
  for(l=0;l<2;l++) {
    for(i=0;i<num_ejemplos_sep[l];i++) {
      for(j=0;j<num_ejemplos_sep[l];j++) {
         UNOKUNO[l] += K[l][i][j];
      }
    }
  }
  UNOKUNO[0] /= (num_ejemplos_sep[0]*num_ejemplos_sep[0]);
  UNOKUNO[1] /= (num_ejemplos_sep[1]*num_ejemplos_sep[1]);
   
  /* Finalmente, transformamos K en Kcentrada (puesto que ya no necesitamos
   * ms K): 
   */  
  for(l=0;l<2;l++) {
    for(i=0;i<num_ejemplos_sep[l];i++) {
      for(j=0;j<num_ejemplos_sep[l];j++) {
         K[l][i][j] = K[l][i][j] - UNOK[l][i] - UNOK[l][j] + UNOKUNO[l];
      }
    }
  }
    
  /* Calculamos ahora la descomposcin espectral de Kcentrada: */ 
  for(l=0;l<2;l++) {
    printf("Calculando descomposicion espectral K%d...",l+1);
    fflush(stdout);
    ENE = num_ejemplos_sep[l];
    car1 = 'V';
    car2 = 'L';
    LWORK = 3*ENE;
    LDA = MAXEJEMPLOSSEP;
    dsyev_(&car1,&car2,&ENE,K[l],&LDA,WW[l],Work,&LWORK,&INFO);
    if(INFO!=0) {
      printf("ERROR en el calculo de valores propios\n");
      exit(-1);
    }
    printf("...Calculada.\n");
    nuevoacum = 0;
    for(i=0;i<num_ejemplos_sep[l];i++)
      nuevoacum += WW[l][i];
    printf("Suma de todos los valores propios= %f\n",nuevoacum);

    acum = 0;
    for(i=0;i<num_ejemplos_sep[l];i++)
      if(WW[l][i]<0)
        acum += WW[l][i];
    printf("Suma de los valores propios negativos= %f\n",acum);
    
    /* Calculamos raiz(m)+(Inv(WW))*beta, y lo ponemos en K):
     * NOTA: Nos quedamos solo con un porcentaje del espectro total de la
     * matriz. 
     */
    if(TANTOPORUNO<=1.0) { 
      acum = 0;
      for(i=num_ejemplos_sep[l]-1;i>=0;i--) {
        acum += WW[l][i];
        if(acum >= TANTOPORUNO*nuevoacum)
          break;
      }
      p = i;
    } else { /*En vez de tantoporuno, tomamos un numero fijo de valores propios.*/
      p = (int) (num_ejemplos_sep[l] - floor(TANTOPORUNO));
      acum = 0;
      for(i=num_ejemplos_sep[l]-1;i>=p;i--) 
        acum += WW[l][i];
    }

    printf("K%d: %d valores propios tomados en cuenta.\n",l,num_ejemplos_sep[l]-p);
    printf("K%d: Suma de los valores propios tomados = %f\n",l,acum);

    acum = sqrt(num_ejemplos_sep[l]);
    for(i=p;i<num_ejemplos_sep[l];i++) {
      for(j=0;j<num_ejemplos_sep[l];j++) {
        K[l][i-p][j] = acum*K[l][i][j]/WW[l][i];
      }  
    }
    num_reduc_sep[l] = num_ejemplos_sep[l]-p;
  }  


  /* Ahora calculamos las distancias a las medias de todos los ejemplos: */
  for(i=0;i<num_ejemplos;i++) {
    jj[0]=-1;
    jj[1]=-1;
    for(j=0;j<num_ejemplos;j++) {
      l = (tabla_ejemplos[j].clase==1?1:0);
      jj[l]++;
      txmmx[l][jj[l]] = kernel(tabla_ejemplos[i].vector,
                               tabla_ejemplos[j].vector) - UNOK[l][jj[l]];
    }

    for(l=0;l<2;l++) {  
      acum2[l] = 0;
      for(iii=0;iii<num_reduc_sep[l];iii++) {
        temp = 0;
        for(j=0;j<num_ejemplos_sep[l];j++) {
          temp += K[l][iii][j]*txmmx[l][j];
        }  
        acum2[l] += temp*temp;
      }
    }

    dist[i][0] = sqrt(acum2[0]);
    dist[i][1] = sqrt(acum2[1]);
    dist[i][2] = 1; /* Componente homognea. */    
  }

  
  /* Ahora sacamos la frontera lineal por mnimos cuadrados: */
  /* Primero la matriz XT.X: */
  for(i=0;i<3;i++) {
    for(j=i;j<3;j++) {
      XTX[i][j] = 0;
      for(k=0;k<num_ejemplos;k++)
        XTX[i][j] += dist[k][i]*dist[k][j];
      if(i!=j) {
        XTX[j][i] = XTX[i][j];
      }
    }
  }
  /* Inversa de una matrix 3x3: */
  valdet = -XTX[0][2]*XTX[0][2]*XTX[1][1] + 2*XTX[0][1]*XTX[0][2]*XTX[1][2]
           -XTX[0][0]*XTX[1][2]*XTX[1][2] - XTX[0][1]*XTX[0][1]*XTX[2][2] +
            XTX[0][0]*XTX[1][1]*XTX[2][2];
  XTXInv[0][0] = (-XTX[1][2]*XTX[1][2]+XTX[1][1]*XTX[2][2])/valdet;
  XTXInv[0][1] = (XTX[0][2]*XTX[1][2]-XTX[0][1]*XTX[2][2])/valdet;
  XTXInv[0][2] = (-XTX[0][2]*XTX[1][1]+XTX[0][1]*XTX[1][2])/valdet;
  XTXInv[1][0] = XTXInv[0][1];
  XTXInv[1][1] = (-XTX[0][2]*XTX[0][2]+XTX[0][0]*XTX[2][2])/valdet;
  XTXInv[1][2] = (XTX[0][1]*XTX[0][2]-XTX[0][0]*XTX[1][2])/valdet;
  XTXInv[2][0] = XTXInv[0][2];  
  XTXInv[2][1] = XTXInv[1][2];
  XTXInv[2][2] = (-XTX[0][1]*XTX[0][1]+XTX[0][0]*XTX[1][1])/valdet;
  /* Clculo de XT.b :*/    
  for(i=0;i<3;i++) {
    XTB[i] = 0;
    for(j=0;j<num_ejemplos;j++) {
      if(tabla_ejemplos[j].clase==1) {
        XTB[i] += dist[j][i];
      } else {
        XTB[i] -= dist[j][i];
      }
    }
  }
  /* Clculo final de W (W[0],W[1],W[3]=b)*/
  for(i=0;i<3;i++) {
    W[i] = 0;
    for(j=0;j<3;j++) {
      W[i] += XTXInv[i][j]*XTB[j];
    }
  }

  times(&buffer_time);

  printf("Tiempo (minutos de CPU)=%2.2f\n",
         (double)(buffer_time.tms_utime-tiempo)/(CLK_TCK*60));

  /* Imprimimos la matriz K (Que ahora es theta del artculo):*/
  /*printf("K:\n");
  for(i=0;i<num_vec_reduc;i++) {
    for(j=0;j<num_ejemplos;j++) {
        printf("%lf ",K[i][j]);
    }
    printf("\n");
  }*/

  /* Ya est lo que necesitamos: theta, y mu-sub-x (que no es ms que el
   * vector UNOK que calculamos antes). */
   
  /* Escribimos la maquina en el fichero: */
  escribir_maquina(argv[3]);
  
  return 0;
}


void leer_ejemplos(char *fichero)
{
  int i,clase,atributo;
  double valor;
  FILE *f;

  f=fopen(fichero,"r");
  if(f==NULL) {
    perror("Error en apertura de fichero de ejemplos.");
    exit(-1);
  }
  fscanf(f,"%d",&clase);
  num_ejemplos=0;
  num_dimensiones=0;

  while(1) {
    tabla_ejemplos[num_ejemplos].clase = clase;
    for(i=0;i<MAXDIM;i++)
      tabla_ejemplos[num_ejemplos].vector[i] = 0.0;   
    while(fscanf(f,"%d:%lf ",&atributo,&valor)==2){
      tabla_ejemplos[num_ejemplos].vector[atributo-1] = valor;
      if(atributo>num_dimensiones)
        num_dimensiones=atributo;
    }
    num_ejemplos++;
    if(feof(f)){
      break;
    }
    clase=atributo;
  }
  fclose(f);
}

void escribir_maquina(char *fichero)
{
  int i,j,l;
  FILE *f;

  f=fopen(fichero,"w");
  if(f==NULL) {
    perror("Error en escritura de fichero de maquina.");
    exit(-1);
  }

  /* Escribimos el valor de gamma: */
  fprintf(f,"%f\n",gamm);
  /* Escribimos el separador lineal (vector W): */  
  fprintf(f,"%f %f %f\n",W[0],W[1],W[2]);  
  /* Ahora escribimos los dos vectores y matrices: */
  for(l=0;l<2;l++) {
    /* Escribimos el numero de ejemplos: */
    fprintf(f,"%d\n",num_ejemplos_sep[l]);
    /* Escribimos el numero de filas de la matriz: */
    fprintf(f,"%d\n",num_reduc_sep[l]);
    /* Escribimos el vector mu-x */
    for(i=0;i<num_ejemplos_sep[l];i++) 
      fprintf(f,"%f ",UNOK[l][i]);
    fprintf(f,"\n");
    /* Escribimos la matriz theta: */
    for(i=0;i<num_reduc_sep[l];i++) {
      for(j=0;j<num_ejemplos_sep[l];j++) {
        fprintf(f,"%f ",K[l][i][j]);
      }
      fprintf(f,"\n");  
    }
    /*fprintf(f,"\n");*/
  }  

  /* Escribimos los ejemplos del modelo: */
  for(i=0;i<num_ejemplos;i++) {
    fprintf(f,"%d ",tabla_ejemplos[i].clase);
    for(j=0;j<num_dimensiones;j++) 
      if(tabla_ejemplos[i].vector[j]!=0.0)
        fprintf(f,"%d:%f ",j+1,tabla_ejemplos[i].vector[j]);
    fprintf(f,"\n");
  }
  fclose(f);  
}


double kernel(double *v1,double *v2)
{
  int i;
  double acum=0;
  
  /* RBF: */
  for(i=0;i<num_dimensiones;i++) {
    acum += (v1[i]-v2[i])*(v1[i]-v2[i]);
  }
  return exp(-gamm*acum);
  
  /* LINEAL: */
/*  for(i=0;i<num_dimensiones;i++) {
    acum += v1[i]*v2[i];
  }
  return acum;*/
}
